class ConsoleAuth::Restriction::Method
  attr_accessor :name, :roles

  def initialize(name, &blk)
    @name  = name
    @roles = Array.new
    @allow_unauthenticated = false

    self.instance_exec &blk
  end

  #This method satisfies both the roles call within
  # the DSL as well to retrieve the assigned roles
  def roles(*args)
    if args.empty?
      @roles
    else
      @roles = @roles + args
    end
  end

  def allow_unauthenticated
    @allow_unauthenticated = true
  end

  def allow_unauthenticated?
    @allow_unauthenticated
  end

  def authorized?(params)
    if params[:roles].empty?
      return @allow_unauthenticated
    end

    @roles.each do |role|
      unless params[:roles].include? role
        return false
      end
    end

    true
  end
end
